/**
 * Hlavní semestrální práce z KIV/VSP
 * (c) 2006 - 2007 Ivan Habernal
 * e-mail: habernal@students.zcu.cz
 */
package cz.habi.vsp.sem.distribution;

/**
 * This class implements the normal distribution. It uses the Central limit
 * theorem.
 * 
 * @author habi
 * 
 */
public class NormalDistribution implements Distribution {

	private double a;

	private double sigma;

	/**
	 * Creates a new instance of NormalDistribution with required parameters.
	 * 
	 * @param a
	 *            the 'a' parameter
	 * @param sigma
	 *            the sigma parameter
	 */
	public NormalDistribution(double a, double sigma) {
		this.a = a;
		this.sigma = sigma;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.habi.vsp.sem.distributions.Distribution#getRandomValue()
	 */
	public double getRandomValue() {
		double temp = 0;
		
		for (int i = 0; i < 12; i++) {
			temp += Math.random();
		}
		
		return a + sigma * (temp - 6);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.habi.vsp.sem.distributions.Distribution#getMean()
	 */
	public double getMean() {
		return a;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.habi.vsp.sem.distributions.Distribution#getVariance()
	 */
	public double getVariance() {
		return (sigma * sigma);
	}

}
