/**
 * Hlavní semestrální práce z KIV/VSP
 * (c) 2006 - 2007 Ivan Habernal
 * e-mail: habernal@students.zcu.cz
 */
package cz.habi.vsp.sem.distribution;

/**
 * This class implements the uniform distribution.
 * 
 * @author habi
 */
public class UniformDistribution implements Distribution {

	private double a;

	private double b;

	/**
	 * Creates a new instance of UniformDistribution with required params
	 * 
	 * @param a
	 *            the 'a' parameter
	 * @param b
	 *            the 'b' parameter
	 */
	public UniformDistribution(double a, double b) {
		if (a <= b) {
			this.a = a;
			this.b = b;
		} else {
			this.a = b;
			this.b = a;
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.habi.vsp.sem.distributions.Distribution#getMean()
	 */
	public double getMean() {
		return (a + b) / 2d;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.habi.vsp.sem.distributions.Distribution#getVariance()
	 */
	public double getVariance() {
		return ((b - a) * (b - a)) / 12d;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.habi.vsp.sem.distributions.Distribution#getRandomValue()
	 */
	public double getRandomValue() {

		double randomNumber;

		randomNumber = Math.random();
		if (Math.random() < 0.5)
			randomNumber = 1.0 - randomNumber;

		return ((randomNumber * (b - a)) + a);
	}

}
