/**
 * Hlavní semestrální práce z KIV/VSP
 * (c) 2006 - 2007 Ivan Habernal
 * e-mail: habernal@students.zcu.cz
 */
package cz.habi.vsp.sem.network;

/**
 * This is an interface for single-out queue elements. Class implementing this
 * interface can make a connection to the next queue element (an instance of
 * {@link RequestAcceptor})
 * 
 * @author habi
 * 
 */
public interface Connectable {

	/**
	 * Sets the next element in the network, an instance of RequestAcceptor
	 * 
	 * @param requestAcceptor
	 *            request acceptor
	 * @throws IllegalArgumentException
	 *             if requestAcceptor is null
	 */
	public void setNextRequestAcceptor(RequestAcceptor requestAcceptor) throws IllegalArgumentException;

	/**
	 * Returns the request acceptor - the next element in the network.
	 * 
	 * @return request acceptor.
	 */
	public RequestAcceptor getNextRequestAcceptor();
}
