/**
 * Hlavní semestrální práce z KIV/VSP
 * (c) 2006 - 2007 Ivan Habernal
 * e-mail: habernal@students.zcu.cz
 */
package cz.habi.vsp.sem.network;

import cz.zcu.fav.kiv.jsim.JSimException;

/**
 * Classes implementing this interface have the ability to accept the
 * {@link Request}.
 * 
 * @author habi
 * 
 */
public interface RequestAcceptor {

	/**
	 * Accepts the request. The concrete behavior of this method depends on the
	 * type of implementing class.
	 * 
	 * @param request
	 *            request
	 * @throws JSimException
	 *             if an exception occurs while accepting request
	 */
	public void acceptRequest(Request request) throws JSimException;
}
